indico/web/forms/base.py
# This file is part of Indico.
# Copyright (C) 2002 - 2015 European Organization for Nuclear Research (CERN).
#
# Indico is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.
#
# Indico is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Indico; if not, see <http://www.gnu.org/licenses/>.

import weakref

from flask import request, session, flash, g
from flask_wtf import Form
from wtforms import ValidationError
from wtforms.ext.sqlalchemy.fields import QuerySelectField
from wtforms.fields.core import FieldList
from wtforms.form import FormMeta
from wtforms.widgets.core import HiddenInput

from indico.core import signals
from indico.core.auth import multipass
from indico.util.i18n import _
from indico.util.signals import values_from_signal
from indico.util.string import strip_whitespace


class _DataWrapper(object):
    """Wrapper for the return value of generated_data properties"""
    def __init__(self, data):
        self.data = data

    def __repr__(self):
        return '<DataWrapper({!r})>'.format(self.data)


class generated_data(property):
    """property decorator for generated data in forms"""

    def __get__(self, obj, objtype=None):
        if obj is None:
            return self
        if self.fget is None:
            raise AttributeError("unreadable attribute")
        return _DataWrapper(self.fget(obj))


class IndicoFormMeta(FormMeta):
    def __call__(cls, *args, **kwargs):
        # If we are instantiating a form that was just extended, don't
        # send the signal again - it's pointless to extend the extended
        # form and doing so could actually result in infinite recursion
        # if the signal receiver didn't specify a sender.
        if kwargs.pop('__extended', False):
            return super(IndicoFormMeta, cls).__call__(*args, **kwargs)
        extra_fields = values_from_signal(signals.add_form_fields.send(cls))
        # If there are no extra fields, we don't need any custom logic
        # and simply create an instance of the original form.
        if not extra_fields:
            return super(IndicoFormMeta, cls).__call__(*args, **kwargs)
        kwargs['__extended'] = True
        ext_cls = type(b'_Extended' + cls.__name__, (cls,), {})
        for name, field in extra_fields:
            name = 'ext__' + name
            if hasattr(ext_cls, name):
                raise RuntimeError(u'Preference collision in {}: {}'.format(cls.__name__, name))
            setattr(ext_cls, name, field)
        return ext_cls(*args, **kwargs)


class IndicoForm(Form):
    __metaclass__ = IndicoFormMeta

    class Meta:
        def bind_field(self, form, unbound_field, options):
            # We don't set default filters for query-based fields as it breaks them if no query_factory is set
            # while the Form is instantiated. Also, it's quite pointless for those fields...
            # FieldList simply doesn't support filters.
            no_filter_fields = (QuerySelectField, FieldList)
            filters = [strip_whitespace] if not issubclass(unbound_field.field_class, no_filter_fields) else []
            filters += unbound_field.kwargs.get('filters', [])
            bound = unbound_field.bind(form=form, filters=filters, **options)
            bound.get_form = weakref.ref(form)  # GC won't collect the form if we don't use a weakref
            return bound

    def generate_csrf_token(self, csrf_context=None):
        if not self.csrf_enabled:
            return None
        return session.csrf_token

    def validate_csrf_token(self, field):
        if self.csrf_enabled and field.data != session.csrf_token:
            if not g.get('flashed_csrf_message'):
                # Only flash the message once per request. We may end up in here
                # multiple times if `validate()` is called more than once
                flash(_(u'It looks like there was a problem with your current session. Please submit the form again.'),
                      'error')
                g.flashed_csrf_message = True
            raise ValidationError(_(u'CSRF token missing'))

    def validate(self):
        valid = super(IndicoForm, self).validate()
        return valid and all(values_from_signal(signals.form_validated.send(self), single_value=True))

    def populate_obj(self, obj, fields=None, skip=None, existing_only=False):
        """Populates the given object with form data.

        If `fields` is set, only fields from that list are populated.
        If `skip` is set, fields in that list are skipped.
        If `existing_only` is True, only attributes that already exist on `obj` are populated.

        Attributes starting with ``ext__`` are always skipped as they
        are from plugin-defined fields which should always be handled
        separately.
        """
        def _included(field_name):
            if fields and field_name not in fields:
                return False
            if skip and field_name in skip:
                return False
            if existing_only and not hasattr(obj, field_name):
                return False
            if field_name.startswith('ext__'):
                return False
            return True

        # Populate data from actual fields
        for name, field in self._fields.iteritems():
            if not _included(name):
                continue
            field.populate_obj(obj, name)

        # Populate generated data
        for name, value in self.generated_data.iteritems():
            if not _included(name):
                continue
            setattr(obj, name, value)

    @property
    def visible_fields(self):
        """A list containing all fields that are not hidden."""
        return [field for field in self if not isinstance(field.widget, HiddenInput)]

    @property
    def error_list(self):
        """A list containing all errors, prefixed with the field's label.'"""
        all_errors = []
        for field_name, errors in self.errors.iteritems():
            for error in errors:
                if isinstance(error, dict) and isinstance(self[field_name], FieldList):
                    for field in self[field_name].entries:
                        all_errors += ['{}: {}'.format(self[field_name].label.text, sub_error)
                                       for sub_error in field.form.error_list]
                else:
                    all_errors.append('{}: {}'.format(self[field_name].label.text, error))
        return all_errors

    @property
    def generated_data(self):
        """Returns a dict containing all generated data"""
        cls = type(self)
        return {field: getattr(self, field).data
                for field in dir(cls)
                if isinstance(getattr(cls, field), generated_data)}

    @property
    def data(self):
        """Extends form.data with generated data from properties"""
        data = {k: v for k, v in super(IndicoForm, self).data.iteritems() if not k.startswith('ext__')}
        data.update(self.generated_data)
        return data


class FormDefaults(object):
    """Simple wrapper to be used for Form(obj=...) default values.

    It allows you to specify default values via kwargs or certain attrs from an object.
    You can also set attributes directly on this object, which will act just like kwargs

    :param obj: The object to get data from
    :param attrs: Set of attributes that may be taken from obj
    :param skip_attrs: Set of attributes which are never taken from obj
    :param defaults: Additional values which are used only if not taken from obj
    """

    def __init__(self, obj=None, attrs=None, skip_attrs=None, **defaults):
        self.__obj = obj
        self.__use_items = hasattr(obj, 'iteritems') and hasattr(obj, 'get')  # smells like a dict
        self.__obj_attrs = attrs
        self.__obj_attrs_skip = skip_attrs
        self.__defaults = defaults

    def __valid_attr(self, name):
        """Checks if an attr may be retrieved from the object"""
        if self.__obj is None:
            return False
        if self.__obj_attrs is not None and name not in self.__obj_attrs:
            return False
        if self.__obj_attrs_skip is not None and name in self.__obj_attrs_skip:
            return False
        return True

    def __setitem__(self, key, value):
        self.__defaults[key] = value

    def __setattr__(self, key, value):
        if key.startswith('_{}__'.format(type(self).__name__)):
            object.__setattr__(self, key, value)
        else:
            self.__defaults[key] = value

    def __getattr__(self, item):
        if self.__valid_attr(item):
            if self.__use_items:
                return self.__obj.get(item, self.__defaults.get(item))
            else:
                return getattr(self.__obj, item, self.__defaults.get(item))
        elif item in self.__defaults:
            return self.__defaults[item]
        else:
            raise AttributeError(item)


class SyncedInputsMixin(object):
    """Mixin for a form having inputs using the ``SyncedInputWidget``.

    This mixin will process the synced fields, adding them the necessary
    attributes for them to render and work properly.  The fields which
    are synced are defined by ``multipass.synced_fields``.

    :param synced_fields: set -- a subset of ``multipass.synced_fields``
                          which corresponds to the fields currently
                          being synchronized for the user.
    :param synced_values: dict -- a map of all the synced fields (as

indico/web/assets/blueprint.py
# This file is part of Indico.
# Copyright (C) 2002 - 2015 European Organization for Nuclear Research (CERN).
#
# Indico is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.
#
# Indico is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Indico; if not, see <http://www.gnu.org/licenses/>.

import binascii
import os

from flask import current_app, json, session, render_template, Response
from werkzeug.exceptions import NotFound

from indico.core.config import Config
from indico.core.plugins import plugin_engine
from indico.modules.users.util import serialize_user
from indico.util.caching import make_hashable
from indico.util.i18n import po_to_json
from indico.web.flask.util import send_file
from indico.web.flask.wrappers import IndicoBlueprint
from indico.web.assets.vars_js import generate_global_file

assets_blueprint = IndicoBlueprint('assets', __name__, url_prefix='/assets')


@assets_blueprint.route('/js-vars/global.js')
def js_vars_global():
    """
    Provides a JS file with global definitions (all users)
    Useful for server-wide config options, URLs, etc...
    """
    config = Config.getInstance()
    config_hash = binascii.crc32(repr(make_hashable(sorted(config._configVars.items())))) & 0xffffffff
    cache_file = os.path.join(config.getXMLCacheDir(), 'assets_global_{}.js'.format(config_hash))

    if not os.path.exists(cache_file):
        data = generate_global_file(config)
        with open(cache_file, 'wb') as f:
            f.write(data)

    return send_file('global.js', cache_file,
                     mimetype='application/x-javascript', no_cache=False, conditional=True)


@assets_blueprint.route('/js-vars/user.js')
def js_vars_user():
    """
    Provides a JS file with user-specific definitions
    Useful for favorites, settings etc.
    """
    user = session.user
    if user is None:
        user_vars = {}
    else:
        user_vars = {
            'id': user.id,
            'first_name': user.first_name,
            'last_name': user.last_name,
            'favorite_users': {u.id: serialize_user(u) for u in user.favorite_users}
        }
    data = render_template('assets/vars_user.js', user_vars=user_vars, user=user)
    return Response(data, mimetype='application/x-javascript')


def locale_data(path, name, domain):
    po_file = os.path.join(path, name, 'LC_MESSAGES', 'messages-js.po')
    return po_to_json(po_file, domain=domain, locale=name) if os.access(po_file, os.R_OK) else {}


@assets_blueprint.route('/i18n/<locale_name>.js')
def i18n_locale(locale_name):
    """
    Retrieve a locale in a Jed-compatible format
    """
    config = Config.getInstance()
    root_path = os.path.join(current_app.root_path, 'translations')
    plugin_key = ','.join(sorted(plugin_engine.get_active_plugins()))
    plugin_hash = binascii.crc32(plugin_key) & 0xffffffff
    cache_file = os.path.join(config.getXMLCacheDir(), 'assets_i18n_{}_{}.js'.format(locale_name, plugin_hash))

    if not os.path.exists(cache_file):
        i18n_data = locale_data(root_path, locale_name, 'indico')
        if not i18n_data:
            # Dummy data, not having the indico domain would cause lots of failures
            i18n_data = {'indico': {'': {'domain': 'indico',
                                         'lang': locale_name}}}

        for pid, plugin in plugin_engine.get_active_plugins().iteritems():
            data = {}
            if plugin.translation_path:
                data = locale_data(plugin.translation_path, locale_name, pid)
            if not data:
                # Dummy entry so we can still load the domain
                data = {pid: {'': {'domain': pid,
                                   'lang': locale_name}}}
            i18n_data.update(data)

        if not i18n_data:
            raise NotFound("Translation for language '{}' not found".format(locale_name))

        with open(cache_file, 'wb') as f:
            f.write("window.TRANSLATIONS = {};".format(json.dumps(i18n_data)))

    return send_file('{}.js'.format(locale_name), cache_file, mimetype='application/x-javascript',
                     no_cache=False, conditional=True)

indico/web/templates/_clipboard_input.html
{%- macro clipboard_input(value, name='') -%}
    <div class="i-has-action i-has-action-clip">
        <input name="{{ name }}" type="text" value="{{ value }}" readonly>{#
        #}<button type="button"
         class="i-button icon-clipboard" title="Click to copy the URL"></button>
    </div>
    <span class="i-has-action-message icon-checkmark"></span>
{%- endmacro -%}

indico/web/templates/_password.html
{%- macro password(id, name=none, value='', classes='', toggle=False) -%}
    <div class="i-has-action {{ classes }}">
        <input id="{{ id }}" name="{{ name }}" type="password" value="{{ value }}"{% if toggle %} autocomplete="off"{% endif %} {{ kwargs|html_params }}>
        {%- if toggle -%}
            <button id="{{ id }}-action-button" type="button" class="i-button icon-eye-blocked"
                    title="{% trans %}Click to show/hide the password{% endtrans %}" data-tooltip-anchor></button>
        {% endif %}
    </div>
    {%- if toggle -%}
        <script>
            $('#{{ id }}-action-button').on('click', function toggleInputType(){
                $('#{{ id }}-action-button').toggleClass('icon-eye icon-eye-blocked');
                var $input = $('#{{ id }}');
                $input.prop('type', $input.prop('type') === 'text' ? 'password' : 'text');
            });
        </script>
    {% endif %}
{%- endmacro -%}

indico/web/templates/_switch.html
{% macro switch(value='1', id=none, name=none, on_label=none, off_label=none) -%}
    {%- set on_label = _('Yes') if on_label is none else on_label -%}
    {%- set off_label = _('No') if off_label is none else off_label -%}

    <label class="switch">
        <input type="checkbox" class="switch-input" value="{{ value }}" {{ kwargs | html_params }}
               {%- if id %} id="{{ id }}"{% endif -%}
               {%- if name %} name="{{ name }}"{% endif -%}>
        <span class="switch-label" data-on="{{ on_label }}" data-off="{{ off_label }}"></span>
        <span class="switch-handle"></span>
    </label>
{%- endmacro %}

indico/web/templates/base.html
<!DOCTYPE html>
<html>
<head>
    <title>Indico{% if self.title() %} - {% endif %}{% block title %}{% endblock %}</title>
    <meta charset="UTF-8">
    <link rel="shortcut icon" type="image/x-icon" href="{{ system_icon('addressBarIcon') }}">

    <script>
        var ScriptRoot = {{ indico_config.ScriptBaseURL | tojson }};
    </script>

    <script type="text/javascript" src="{{ url_for('assets.i18n_locale', locale_name=(session.lang or get_default_language)) }}"></script>
    <script type="text/javascript" src="{{ url_for('assets.js_vars_global') }}"></script>

    {% assets 'base_js' -%}
    <script src="{{ ASSET_URL }}"></script>
    {% endassets %}

    {% assets 'base_css', 'screen_sass' -%}
        <link rel="stylesheet" type="text/css" href="{{ ASSET_URL }}">
    {% endassets %}

    {#
    If you need custom assets, copy the assets tag from above and use your bundle name instead.
    And of course do not edit this file but put the block in YOUR template!
    #}
    {% block head %}{% endblock %}
</head>
<body>
    {% block body %}{% endblock %}
</body>
</html>

indico/web/templates/flashed_messages.html
{% from 'message_box.html' import message_box %}
{% with messages = get_flashed_messages(with_categories=True) %}
    <div id="flashed-messages" class="flashed-messages">
        {%- for category, message in messages %}
            {{ message_box(category, message) }}
        {% endfor -%}
    </div>
{% endwith %}

indico/web/templates/message_box.html
{% macro message_box(type, message=none, fixed_width=false) %}
    <div class="{{ type }}-message-box {%- if fixed_width %} fixed-width{% endif %}" {{ kwargs | html_params }}>
        <div class="message-text">
            {{ message or caller() }}
        </div>
    </div>
{% endmacro %}